
/* Chrysalide - Outil d'analyse de fichiers binaires
 * cse-int.h - prototypes pour la définition interne des types classes / structures / énumérations
 *
 * Copyright (C) 2012-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_TYPES_CSE_INT_H
#define _ANALYSIS_TYPES_CSE_INT_H


#include "cse.h"
#include "../type-int.h"



/* Description de type classe/structure et enumeration (instance) */
struct _GClassEnumType
{
    GDataType parent;                       /* A laisser en premier        */

    ClassEnumType type;                     /* Type représenté si connu    */
    char *name;                             /* Description humaine         */

};

/* Description de type classe/structure et enumeration (classe) */
struct _GClassEnumTypeClass
{
    GDataTypeClass parent;                  /* A laisser en premier        */

};


/* Décrit le type fourni sous forme de caractères. */
char *g_class_enum_type_to_string(const GClassEnumType *);

/* Procède à l'impression de la description d'un type. */
//void g_class_enum_type_output(const GClassEnumType *, GLangOutput *, GBufferLine *, bool, bool);



#endif  /* _ANALYSIS_TYPES_CSE_INT_H */
